exec("./devirtualize.cs");

datablock AudioProfile(CLPainSound)
{
   filename    = "./Williampain.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(CLJumpSound)
{
   filename    = "./Williamjump.wav";
   description = AudioClose3d;
   preload = true;
};

datablock playerData(WilliamBossPlayer : playerStandardArmor)
{
	MaxrunSpeed = 18;
	MaxSideSpeed = 9;
	Aircontrol = 2;
	JumpForce = 0;
	isWilliam = true;
	canJet = 0;
	uiName = "William";

	useCustomPainEffects = true;
	painSound = "painCrySound";
	deathSound = "CLPainSound";
};

function Player::williamJumpCharge(%this, %val, %start)
{
	if(!isobject(%this) || %this.isDisabled())
		return;

	if(!%start && !%this.isJumpCharging)
		return;

	if(%val)
	{
		%this.isJumpCharging = true;
		if(%this.jumpCharge < 150)
			%this.jumpCharge++;
		if(isObject(%this.client))
			%this.client.bottomPrint("<color:a0a0a0>Jump charge:" SPC %this.jumpCharge,1,0);
		%this.schedule(20, williamJumpCharge, 1, false);
		return;
	}

	else if(%this.isJumpCharging && !%val)
	{
		%this.isJumpCharging=0;
		%this.lastSuperJump = $sim::time;
		if(%this.jumpCharge < 20 && %this.jumpCharge > 1)
		{
			%this.jumpCharge = 30;
			serverplay3d(jumpSound, %this.getposition());
			%this.lastSuperJump = $sim::time - 2;
		}
		%this.playthread(0, jump);
		if(%this.jumpCharge > 90)
		{
			serverplay3d(CLJumpsound, %this.getposition());
			%this.spawnExplosion(CLBladeProjectile, "1.0");
		}
		%x = %this.jumpCharge/5;
		%z = %this.jumpCharge/3;
		%this.addRelativeVelocity("0" SPC %x SPC %z);
		%this.jumpCharge=0;
		return;
	}
}

package WilliamBossfunctions
{
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getDatablock().isWilliam)
		{
			if(%slot == 2 && %player.lastSuperJump + 3 < $sim::time)
			{
				%player.WilliamJumpCharge(%val, true);
			}

			if(%slot == 4)
			{
				if(%player.lastThrust + 5 < $sim::time)
				{
					%player.lastThrust = $sim::time;
					%x = 25;
					%z = 7;
					%player.addRelativeVelocity( "0" SPC %x SPC %z);
				}
			}
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}

	function WilliamBossPlayer::onDisabled(%this, %obj, %enabled)
	{
		parent::ondisabled(%this, %obj, %enabled);
		%obj.CLDevirtualize();
	}
};
activatepackage(WilliamBossFunctions);

//thanks Truce
function Player::addRelativeVelocity(%player,%xyz)
{
	%x = getWord(%xyz,0);
	%y = getWord(%xyz,1);
	%z = getWord(%xyz,2);
	%forwardVector = %player.getForwardVector();
	%forwardX = getWord(%forwardVector,0);
	%forwardY = getWord(%forwardVector,1);
	%player.addVelocity((%x * %forwardY + %y * %forwardX) SPC (%y * %forwardY + %x * -%forwardX) SPC %z);
}
